package gestionnaire.gui;

import java.awt.BorderLayout;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;



import java.io.File;
import java.io.IOException;

import gestionnaire.Gestionnaire;
import personnage.Personnage;
import gestionnaire.run.EntreesSorties;
import java.awt.Dimension;
import java.awt.event.KeyEvent;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.imageio.ImageIO;
import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.UIManager;
import javax.swing.event.MenuListener;
import javax.swing.event.MouseInputAdapter;
import javax.swing.filechooser.FileNameExtensionFilter;

@SuppressWarnings("serial")
public class GestionnaireUI extends JFrame {
	Gestionnaire gestionnaire;
	JList<Personnage> list_perso;
	DefaultListModel lmodel;
	JPanel content_pane;
private JMenuBar menuBar;

	private JMenu gestionnaire_menu;
	private JMenuItem nouveau;
	private JMenuItem charger;
	private JMenuItem sauvegarder;
	private JFileChooser fileChooser;

	private JPanel container;
	private Dimension dimensionJframe = new Dimension(600, 400);
	private DefaultListModel<String> listModel;
	private JList<String> list;
	private JScrollPane scrollPane;
	private JButton ajouter;
	private int count = 0;
	private String valueSelected = "";

	public GestionnaireUI(){
		init();
		initMenu();
		initListPersonnages();
		initPersonnageIntoList();

		this.setVisible(true);
	}

	private void init(){
		/* Initializing the main JFrame, keeping the default FlowLayout for the Jpanel's content pane */
		this.setTitle("Gestionnaire");
                gestionnaire = new Gestionnaire();
		this.setSize(400, 400); //this.pack();
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		// center the window
		this.setLocationRelativeTo(null); 
		// Instanciate a content pane
		content_pane = new JPanel();
		content_pane.setLayout(new BoxLayout(content_pane, BoxLayout.PAGE_AXIS));
		content_pane.add(new ImagePanel());

		this.setContentPane(content_pane);


		UIManager.LookAndFeelInfo[] laf=UIManager.getInstalledLookAndFeels();
		for (int i=0;i<laf.length;i++){ 
			System.out.println("Class name: "+laf[i].getClassName());
			System.out.println("Name: "+laf[i].getName());}
		try {UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());}
		catch (Exception e) { }


	}
    
	private void initMenu(){
		// A JMenuBar
		JMenuBar menubar = new JMenuBar();
		JMenu menu = new JMenu("Gestionnaire");	
		menubar.add(menu);
		this.setJMenuBar(menubar);

		/* Créer un nouveau Gestionnaire */
		JMenuItem menu_new = new JMenuItem("Nouveau...");
		menu.add(menu_new);
		menu_new.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				gestionnaire = new Gestionnaire();
				initPersonnageIntoList();
			}
		});

		/* Charger un gestionnaire existant */
		JMenuItem menu_load = new JMenuItem("Charger...");
		menu.add(menu_load);
		class MenuChargerAL implements ActionListener {
			public void actionPerformed(ActionEvent e) {
				JFileChooser filechooser = new JFileChooser(".");
				filechooser.setFileFilter(new FileNameExtensionFilter("Gestionnaire","save"));
				if (filechooser.showOpenDialog(null) == JFileChooser.APPROVE_OPTION){
                                    try {
                                        File file = filechooser.getSelectedFile();	
                                        gestionnaire.chargerPersonnage(file.getAbsolutePath());
                                    } catch (Exception ex) {
                                        Logger.getLogger(GestionnaireUI.class.getName()).log(Level.SEVERE, null, ex);
                                    }
				}

				initPersonnageIntoList();
			}
		}
		menu_load.addActionListener(new MenuChargerAL());

		/* Sauvegarder un gestionnaire existant */
		JMenuItem menu_save = new JMenuItem("Sauvegarder...");
		menu.add(menu_save);
		class MenuSauvegarderAL implements ActionListener {
			public void actionPerformed(ActionEvent e) {
				if (GestionnaireUI.this.gestionnaire != null) {
					JFileChooser filechooser = new JFileChooser(".") {
						public void approveSelection(){
							File f = getSelectedFile();
							if(f.exists()){
								int result = 
										JOptionPane.showConfirmDialog(this,"Écraser le fichier?","Confirmation",JOptionPane.YES_NO_CANCEL_OPTION);
								switch(result){
								case JOptionPane.YES_OPTION:
									super.approveSelection();
									return;
								default:
									super.cancelSelection();
								}
							}
							else
								super.approveSelection();
						}
					};
					if (filechooser.showSaveDialog(null) == JFileChooser.APPROVE_OPTION){
						EntreesSorties.sauvegarderFichier(gestionnaire, filechooser.getSelectedFile());
					}
				}
				else 
					JOptionPane.showMessageDialog(GestionnaireUI.this,"veuillez créer un nouveau gestionnaire ou charger un gestionnaire existant",
							"Erreur", JOptionPane.ERROR_MESSAGE);
			}
		}
		menu_save.addActionListener(new MenuSauvegarderAL());
	}

        
        
        
        
        private void initPersonnageIntoList (){
		if (this.gestionnaire != null){
			lmodel.clear();
			for(Personnage personnage: this.gestionnaire.getPersonnages()){
				lmodel.addElement(personnage);
			}
		}

	}
        
        
        
	private void initListPersonnages (){
		lmodel = new DefaultListModel<Personnage>();
		list_perso = new JList(lmodel);
		/* Scroll pane*/
		JScrollPane scrollpane = new JScrollPane(list_perso);
		this.getContentPane().add(scrollpane);

		/* Adding a Button to add series */
		JButton button_add_personnage = new JButton("Ajouter personnage");
		content_pane.add(button_add_personnage);
                
		class ButtonAddPersoAL implements ActionListener {
			public void actionPerformed (ActionEvent e){
				if (GestionnaireUI.this.gestionnaire != null){
					AddPersonnageDialogUI popup = new AddPersonnageDialogUI(GestionnaireUI.this,gestionnaire, "Ajouter Perso");}
				else
					JOptionPane.showMessageDialog(GestionnaireUI.this,"veuillez créer un nouveau gestionnaire ou charger un gestionnaire existant",
							"Erreur", JOptionPane.ERROR_MESSAGE);
			}
		}
		button_add_personnage.addActionListener(new ButtonAddPersoAL());

		/* Adding a listener for double clicked series in the JList*/
		class listSeriesDoubleClickedAL extends MouseInputAdapter {
			public void mouseClicked(MouseEvent e) {
				if (e.getClickCount() == 2){
					Personnage selected_serie = list_perso.getSelectedValue();
					if (selected_serie != null){
						PersonnagesUI personnage_dialog = new PersonnagesUI(GestionnaireUI.this, gestionnaire);
					}
				}
			}
		}
		list_perso.addMouseListener(new listSeriesDoubleClickedAL());
	}

	
	public static void main(String args[]){
		new GestionnaireUI();
	}

	

	public class ImagePanel extends JComponent {
		public void paintComponent(Graphics g){
			super.paintComponent(g);
			try {
				BufferedImage img = ImageIO.read(new File("./monstre.png"));

				g.drawImage(img,(this.getWidth()-img.getWidth()/2)/2,(this.getHeight()-img.getHeight()/2)/2,
						img.getWidth()/2, img.getHeight()/2, null);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

	}

}