package gestionnaire.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;

import gestionnaire.Gestionnaire;

import gestionnaire.gui.AddPersonnageDialogUI;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.RowFilter;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.MouseInputAdapter;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableRowSorter;
import personnage.Personnage;

public class PersonnagesUI extends JDialog {
	Personnage personnage;
	JTable list_personnages;
	DefaultTableModel tmodel;
	JPanel content_pane;
	Gestionnaire gestionnaire;

	public PersonnagesUI(JFrame owner, Gestionnaire gesionnaire){
		super(owner);
		init();
		initListPersonnages();
		initPersonnagesIntoTable();
                gesionnaire = this.gestionnaire;
		pack();

	}
	private void init(){
		this.setSize(400, 400);
		this.setLocationRelativeTo(null); 

		content_pane = new JPanel();
		content_pane.setLayout(new BoxLayout(content_pane, BoxLayout.PAGE_AXIS));
		
		this.setContentPane(content_pane);

		this.setVisible(true);
	}


	private void initListPersonnages (){
		/* Initializing a JList for series */
		String[] colName = { "Nom", "Point vie", "Point force", "Arme ou type" };
		tmodel = new DefaultTableModel() {

		};
		// /!\ Have to set the column Identifiers... or maybe with a DefaultColumnTableModel would work!
		tmodel.setColumnIdentifiers(colName);

		list_personnages = new JTable(tmodel) {
			/* Making only the column Vu? editable!*/
			public boolean isCellEditable(int row, int col){
				switch (col){
				case 3: 
					return true;
				default:
					return false;
				}
			}
			/* Making the column Vu? display a checkbox */
			public Class getColumnClass(int c) {
				return getValueAt(0, c).getClass();
			}
		};

		/* auto sorting when clicking on headers*/
		//list_episodes.setAutoCreateRowSorter(true);
		TableRowSorter<DefaultTableModel> sorter = new TableRowSorter<DefaultTableModel>(tmodel);
		list_personnages.setRowSorter(sorter);

		/* Adding a Listener for Jtable modifications (Column Vu?) */
		TableModelListener jtable_listener = new TableModelListener(){
			/* TODO: this is crappy since it is called everytime the Jtable is changed. 
			 * Even when initializing it, it is fired for non editable cells.
			 *  Find a way of adding a Listener on specifics Cells */
			public void tableChanged(TableModelEvent e) {
				if (e.getColumn() == 3) {
					int row = e.getFirstRow();
					int column = e.getColumn();
					DefaultTableModel model = (DefaultTableModel) e.getSource();
				}
			}
		};

		list_personnages.getModel().addTableModelListener(jtable_listener);

		/* a Scroll pane */ 
		JScrollPane scrollPane = new JScrollPane(list_personnages);
		//ist_episodes.setFillsViewportHeight(true);
		content_pane.add(scrollPane);

		/* Add a sorter to not display seen episodes */
		JCheckBox checkbox = new JCheckBox("Cacher épisodes vu?");
		checkbox.addActionListener( new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(((JCheckBox)e.getSource()).isSelected()){
					TableRowSorter sorter = new TableRowSorter(tmodel);
					sorter.setRowFilter(new RowFilter(){
						public boolean include(Entry entry) {
							if (entry.getValue(3) instanceof Boolean);
							return !(Boolean) entry.getValue(3);
						}
					});
					list_personnages.setRowSorter(sorter);
				}
				else {
					list_personnages.setRowSorter(new TableRowSorter(tmodel) );
				}

			}
		});
		content_pane.add(checkbox);

	}

	private void initPersonnagesIntoTable(){
		tmodel.setRowCount(0); // Clearing the table model
		for(Personnage perso: gestionnaire.getPersonnages()){
			Object[] test = { perso, perso.getNom(), perso.getVie(), perso.getForce()};
			tmodel.addRow( test );
		}
	}

}
