package gestionnaire.run;

import java.util.ArrayList;

import gestionnaire.Gestionnaire;

public abstract class Menu {

	protected Gestionnaire gestionnaire;
	private ArrayList<String> actions;

	public Menu() {
		gestionnaire = new Gestionnaire();
		actions = new ArrayList<String>();
		actions.add("Charger un gestionnaire");
		actions.add("Afficher les personnages");
		actions.add("Ajouter un personnage");
		actions.add("Sauvegarder le gestionnaire");
	}

	public void derouler () {
		int n;
		while (true) {
			System.out.println(this);
			n = EntreesSorties.lireEntier(0,4);
			switch (n) {
			case 1 : chargerGestionnaire(); break;
			case 2 : afficherPersonnages(); break;
			case 3 : ajouterPersonnage(); break;
			case 4 : sauvegarderGestionnaire(); break;
			case 0 : return;
			default : continue;
			}

		}
	}

	protected abstract void chargerGestionnaire();
	
	protected abstract void afficherPersonnages();

	protected abstract void ajouterPersonnage();
	
	protected abstract void sauvegarderGestionnaire();



	@Override
	public String toString() {
		String res = new String();
		res += "-------------------------------\n";

		for(int i = 0; i<actions.size(); i++) {
			res += (i+1) +" : " + actions.get(i)+ "\n";
		}
		res += "0 : Terminer\n";
		return res;
	}


}
